unit user;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Db, ExtCtrls, ADODB, Grids, DBGrids;

type
  TFormuser = class(TForm)
    ADOConnection1: TADOConnection;
    ADODataSet1: TADODataSet;
    DataSource1: TDataSource;
    ADODataSet1DSDesigner: TWideStringField;
    ADODataSet1DSDesigner2: TWideStringField;
    ADODataSet1DSDesigner3: TWideStringField;
    Panel1: TPanel;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    DBGrid1: TDBGrid;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ADOQuery1: TADOQuery;
    DataSource2: TDataSource;
    ADOQuery2: TADOQuery;
    ADOQuery3: TADOQuery;
    ADOQuery3DSDesigner: TIntegerField;
    ADOQuery3DSDesigner2: TWideStringField;
    ADOQuery3DSDesigner3: TWideStringField;
    ADOQuery1DSDesigner: TWideStringField;
    ADOQuery1DSDesigner2: TIntegerField;
    ADOQuery1Field: TStringField;
    DBGrid2: TDBGrid;
    DataSource3: TDataSource;
    DBGrid3: TDBGrid;
    ADOQuery2DSDesigner: TIntegerField;
    ADOQuery2DSDesigner2: TWideStringField;
    ADOQuery2DSDesigner3: TWideStringField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DBGrid3DblClick(Sender: TObject);
    procedure DBGrid2DblClick(Sender: TObject);
    procedure ADOQuery1AfterPost(DataSet: TDataSet);
    procedure ADOQuery1AfterDelete(DataSet: TDataSet);
    procedure ADOQuery1BeforeInsert(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Formuser: TFormuser;
  procedure cruser;

implementation

{$R *.DFM}

procedure cruser;
begin
   Application.CreateForm(TFormuser, Formuser);
end;

procedure TFormuser.FormCreate(Sender: TObject);
begin
   adoconnection1.Connected:=false;
   adoconnection1.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;'+
      'Data Source='+getcurrentdir+'\|p`b޲zt.mdb;'+
      'Persist Security Info=False';
   adoconnection1.Connected:=true;
   adodataset1.Active:=true;
   adoquery1.Active:=true;
   adoquery2.Active:=true;
   adoquery3.Active:=true;
end;

procedure TFormuser.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   action:=cafree;
end;

procedure TFormuser.DataSource1DataChange(Sender: TObject; Field: TField);
begin
   adoquery2.Active:=false;
   adoquery2.SQL.text:='select * from {򥻸 where {N not in (select {N from v where N='
       +quotedstr(adodataset1.fieldbyname('N').asstring)+')';
   adoquery2.Active:=true;
end;

procedure TFormuser.DBGrid3DblClick(Sender: TObject);
begin
   adoquery1.Append;
   adoquery1.FieldByName('{N').asstring:=adoquery2.FieldByName('{N').asstring;
   adoquery1.Post;
end;

procedure TFormuser.DBGrid2DblClick(Sender: TObject);
begin
   adoquery1.Delete;
end;

procedure TFormuser.ADOQuery1AfterPost(DataSet: TDataSet);
begin
   adoquery2.AutoCalcFields:=true;
   adoquery2.Requery;
end;

procedure TFormuser.ADOQuery1AfterDelete(DataSet: TDataSet);
begin
   adoquery2.Requery;
end;

procedure TFormuser.ADOQuery1BeforeInsert(DataSet: TDataSet);
begin
   adoquery2.AutoCalcFields:=false;
end;

end.
